#ifndef XLSEXT_H
#define XLSEXT_H

/* basics.c */
extern LVAL xssequencep(),
  xscopyvector(),
  copyarray(),
  xscopyarray(),
  xssplitlist(),
  xswhich(),
  iseq(),
  xsiseq(),
  xsrepeat(),
  subsequence(),
  old_rowmajor_index(),
  subarray(),
  xsselect(),
  xssetselect(),
  xspermutearray();
#ifdef SAVERESTORE
extern LVAL xsrestore();
#endif

/* betabase.c */
extern void betabase();

/* bivnor.c */
extern double bivnor();

/* cfft.c */
extern int cfft();

/* cholesky.c */
extern void choldecomp();

/* common.c */
extern LVAL xsapropos(),
  xsaproposlist(),
  xsidentity(),
  mklist(),
  xsmklist(),
  xsadjoin(),
  xsfileposition(),
  xsformat(),
  xsforce_output(),
  xscopylist(),
  xscopyseq(),
  argset2(),
  reduce(),
  xsreduce(),
  map(),
  xsmap(),
  xselt(),
  xscoerce(),
  xsapply(),
  xseval(),
  xsload(),
  xsgetreal(),
  newicomplex(),
  newdcomplex(),
  newcomplex(),
  xscomplexp(),
  realpart(),
  imagpart(),
  xsrcomplex(),
  xsrconjugate(),
  xsrrealpart(),
  xsrimagpart(),
  xseql(),
  xsequal(),
  defconstant(),
  defsym(),
  xsdefconstant(),
  xsdefparameter(),
  xsdefvar(),
  xsmakunbound(),
  xsfmakunbound();
extern int keep_do_strings();
extern void set_function_docstring(),
  set_variable_docstring();
extern int checkfeatures();
extern LVAL xstime(),
  xs_get_internal_run_time(),
  xs_get_internal_real_time(),
  xsgetenv(),
  concatenate),
  xsconcatenate(),
  xssome(),
  xsevery(),
  xsnotany(),
  xsnotevery(),
  xsunion(),
  xsintersection(),
  xsset_difference(),
  xssubsetp(), 
  xsremove_duplicates(),
  xsbutlast(),
  xsmake_string(),
  xsfind(),
  xsposition(),
  xserror(),
  xsbreak();

/* commonarrays.c */
extern LVAL sxgetarray(),
  xsgetdisplacedarray();
extern int displacedarrayp(),
  simplevectorp(),
  checkdims(),
  arrayp(),
  checharrayp(),
  inboundsp();
extern LVAL arraydata(),
  displacedarraydim();
extern int arrayrank();
extern LVAL makedisplacedarray(),
  xsarrayp(),
  xsarraydimensions(),
  xsarrayrank(),
  xsarraytotalsize(),
  xsarraydimension(),
  xsarrayinboundsp();
extern int rowmajorindex();
extern LVAL xsarrayrowmajorindex(),
  xsaref(),
  newarray(),
  nested_list_to_array(),
  xsmakearray();
extern void evsetarrayelement();
extern LVAL array_to_nested_list();
extern void putarray();

/* commonmath.c */
extern LVAL xadd(),
  xsub(),
  xmul(),
  xdiv(),
  xmin(),
  xmax(),
  xlogand(),
  xlogior(),
  xlogxor(),
  binary(),
  xrem(),
  logbinary(),
  xexpt(),
  xlog(),
  xgcd();
extern void checkizero(),
  checkfzero();
extern LVAL xlognot(),
  xabs(),
  xadd1(),
  xsub1(),
  xsin(),
  xcos(),
  xtan(),
  xexp(),
  xsqrt(),
  xfix(),
  xfloat(),
  xrand(),
  xfloor(),
  xceil(),
  xround(),
  xasin(),
  xacos(),
  xatan(),
  xphase(),
  xminusp(),
  xzerop(),
  xplusp(),
  xevenp(),
  xoddp(),
  xlss(),
  xleq(),
  xequ(),
  xneq(),
  xgeq(),
  xgtr(),
  ccompare();
extern double logarithm();

/* complex.c */
extern Complex makecomplex();
extern double phase(),
  modulus();
extern Complex cart2complex();
extern LVAL cvcomplex();
extern Complex polar2complex(),
  csqrt(),
  cexp(),
  clog(),
  cexpt(),
  cadd(),
  csub(),
  cmul(),
  cdiv(),
  csin(),
  ccos()c
  ctan(),
  cacos(),
  catan();

/* compound.c */
extern int compoundp();
extern LVAL xscompoundp(),
  checkcompound();
extern int compounddatalen();
extern LVAL xscompound_length(),
  compounddataseq(),
  xscompound_seq(),
  makecompound(),
  subr_map_elements(),
  recursive_subr_map_elements(),
  xsmap_elements();

/* ddistributions.c */
extern LVAL xsrbinomialcdf(),
  xsrpoissoncdf(),
  xsrbinomialpmf(),
  xsrpoissonpmf(),
  xsrbinomialquant(),
  xsrpoissonquant(),
  xsrbinomialrand(),
  xsrpoissonrand();

/* derivatives.c */
extern void numergrad(),
  numerhess();

/* distributions.c */
extern LVAL xsrnormalcdf(),
  xsrbetacdf(),
  xsrgammacdf(),
  xsrchisqcdf(),
  xsrtcdf(),
  xsrfcdf(),
  xsrcauchycdf(),
  xsrloggamma(),
  xsrbnormcdf(),
  xsrnormalquant(),
  xsrcauchyquant(),
  xsrbetaquant(),
  xsrgammaquant(), 
  xsrchisqquant(),
  xsrtquant(),
  xsrfquant(),
  xsrnormaldens(),
  xsrcauchydens(),
  xsrbetadens(),
  xsrgammadens(),
  xsrchisqdens(),
  xsrtdens(),
  xsrfdens(),
  xsruniformrand(),
  xsrnormalrand(),
  xsrcauchrand(),
  xsrgammarand(),
  xsrchisqrand(),
  xsrtrand(),
  xsrbetarand(),
  xsrfrand();

/* functions.c */
extern void evalfront(),
#ifdef SBAYES
  gevalfront(),
  derivscalefront(),
  samplefront(),
#endif SBAYES
  constfunc(),
  maxfront(),
  loglapdet(),
  loglapfront();
#ifdef SBAYES
extern void moms1front(),
  moms2front(),
  lapmar1front();
#endif SBAYES

/* gamln.c */
extern double gamma();

/* gammabase.c */
extern void gammabase();
extern double ppgamma();

/* kernel.c */
extern int kernel_smooth();

/* linalg.c */
extern IVector ivector();
extern RVector rvector();
extern CVector cvector();
extern void free_vector();
extern IMatrix imatrix();
extern RMatrix rmatrix();
extern CMatrix cmatrix();
extern void free_matrix();
extern double macheps();
extern LVAL xslu_decomp(),
  xslu_solve(),
  xslu_determinant(),
  xslu_inverse(), 
  xssv_decomp(),
  xsqr_decomp(),
  xschol_decomp(),
  xsrcondest(),
  xsmake_rotation(),
  xsspline(),
  xskernel_smooth(),
  xskernel_dens(), 
  xsbase_lowess(),
  xssurface_contour(),
  xsfft();

/* lowess.c */
extern int lowess();

/* ludecomp.c */
extern int crludcmp(),
  crlubksh();

/* makerotation.c */
extern void makerotation();

/* math.c */
extern LVAL xsradd(),
  xsrsub(),
  xsrmul(),
  xsrdiv(),
  xsrrem(),
  xsrmin(),
  xsrmax(),
  xsrexpt(),
  xsrlog(),
  xsrlogand(),
  xsrlogior(),
  xsrlogxor(),
  xsrlognot(),
  xsrabs(),
  xsradd1(),
  xsrsub1(),
  xsrsin(),
  xsrcos(),
  xsrtan(),
  xsrexp(),
  xsrsqrt(),
  xsrfix(),
  xsrfloat(),
  xsrrand(),
  xsrfloor(),
  xsrceil(),
  xsrround(),
  xsrasin(),
  xsracos(),
  xsratan(),
  xsrphase(),
  xsrminusp(),
  xsrzerop(),
  xsrplusp(),
  xsrevenp(),
  xsroddp(),
  xsrlss(),
  xsrleq(),
  xsrequ(),
  xsrneq(),
  xsrgeq(),
  xsrgtr();

/* matrices1.c */
extern int matrixp();
extern LVAL xsgetmatrix();
extern int numrows(),
  numcols();
extern LVAL innerproduct();
extern void copy_row(),
  copy_column();
extern LVAL xsmatmult(),
  xscrossproduct(),
  xsouterproduct(),
  diagonal(),
  xsdiagonal(),
  identitymatrix(),
  xsidentitymatrix(),
  facelist(),
  xsrowlist(),
  xscolumnlist(),
  xsbindrows(),
  xsbindcols(),
  xstranspose();

/* matrices2.c */
extern LVAL xsmakesweepmatrix();
extern int sweep_in_place();
extern LVAL xssweepoperator();

/* minimize.c */
extern int minworkspacesize();
extern char *minresultstring();
extern void minsetup(),
  minsetoptions(),
  minsupplyvalues(),
  minimize(),
  minresults();
extern double pdlogdet();

/* nor.c */
extern void normbase();

/* objectinit.c */
extern void init_objects();

/* objects.c */
extern LVAL xskind_of_p(),
  xsobject_null_method();
extern int mbject_p(),
  kind_of_p(); 
extern LVAL xsmake_object(),
  xsreparent_object(),
  slot_value();
extern void check_hooks;
extern LVAL set_slot_value,
  xshas_slot(),
  xsadd_slot(),
  xsdelete_slot(),
  xsslot_value(),
  xshas_method(),
  xsadd_method(),
  xsdelete_method(),
  xsmessage_method(),
  send_message_stk(),
  xmsendsuper(),
  xscall_next(),
  xmsend(),
  xscall_method();
extern void print_mobject();
extern LVAL xsshow_object(),
  xsparents(),
  xsprecedence_list(),
  xsobject_methods(),
  xsobject_slots();
extern void statobsymbols();
extern int lex_slot_value();
extern void object_isnew();
extern LVAL xsobject_isnew();
extern void xsaddmsg(),
  xsaddslot();
extern LVAL xsnewproto(),
  init_root_object(),
  xsobject_documentation(),
  xsdefmeth();
extern void xsaddinstanceslot(),
  xssetslotval();
extern LVAL xsdefproto(),
  xsmakeproto(),
  clanswer(),
  clisnew(),
  clnew();
extern void obsymbols();
extern LVAL obclass(),
  obshow(),
  obisnew(),
  xsend();
extern int xlobgetvalue(),
  xlobsetvalue();
extern LVAL xsendsuper();
extern void xloinit();

/* optimize.c */
#ifdef OPTIMIZE
extern LVAL xsbracket_search(),
  xsgolden_search(),
  xsparabolic_search();
#endif OPTIMIZE

/* ppnd.c */
extern double ppnd();

/* qrdecomp.c */
extern void qrdecomp();

/* rcondest.c */
extern double rcondest();
extern void backsolve();

/* sortdata.c */
extern LVAL lsort(),
  xssortdata(),
  xsorder(),
  xsrank();

/* splines.c */
extern int fit_spline();

/* statfloat.c */
extern double f_plus(),
  f_minus(),
  f_times(),
  f_divide(),
  f_log(),
  f_exp(),
  f_sqrt(),
  f_expt();

/* statinit.c */
extern void statfinit(),
  statsymbols();

/* statistics.c */
extern LVAL xssum(),
  xsprod(),
  xsmin(),
  xsmax(),
  xscount(),
  elementseq(),
  xselement_seq(),
  xsquantile(), 
  xsifelse(),
  xsmean(),
  xssample();

/* studentbase.c */
extern void studentbase();
extern double ppstudent();

/* svdecomp.c */
extern void scdcmp();

/* uni.c */
extern LVAL newrandomstate();
extern double uni();
extern int osrand();
extern LVAL xsmake_random_state(),
  xsrandom_state_p();

/* utilities.c */
extern int llength();
extern LVAL list2(),
  list3(),
  peekarg();
extern LVAL getnextarg(),
  getnextelement(),
  xsgetsequence();
extern void setfixnum(),
  setnextelement();
extern LVAL checknonnegint();
extern double makedouble();
extern void pushargvec();
extern LVAL xsapplysubr(),
  xscallsubrvec(),
  xscallsubr1(),
  xscallsubr2(),
  xsfuncall1(),
  xsfuncall2();
#ifdef DODO
extern char *xstcalloc();
extern void xstfree();
extern double *data_to_double(),
  double_to_matrix(),
  double_to_sequence();
#endif DODO
extern LVAL coerce_to_list(),
  coerce_to_vector(),
  copylist(),
  copyvector(),
  splitlistd(),
  lrepeat(),
  nested_list_to_list();
extern int xsboolkey();

/* utilities2.c */
extern LVAL integer_list_2(),
  integer_list_3(),
  integer_list_4(),
  send_message(),
  send_message1(),
  send_message_1L(),
  apply_send(),
  double_list_2(),
  make_string(),
  xsnumtostring(),
  xssysbeep();

/* windows.c */
extern void get_window_bounds();
extern LVAL xsshowwindow(),
  xshidewindow(),
  xswindow_title(),
  xswindow_location(),
  xsscreen_size(),
  xsscreen_has_color(),
  xswindow_size(),
  xswindow_frame_location(),
  xswindow_frame_size();

/* xsbayes.c */
extern char *S_alloc();
extern void call_S(),Recover();
extern LVAL xsnumgrad(),
  xsnumhess(),
  xsminfo_isnew(),
  xsminfo_maximize(),
  xsminfo_loglap();
#ifdef DODO
extern xsscaled_c2_eval(),
  xsscaled_c2_grad(),
  xsscaled_c2_hess();
#endif DODO
extern LVAL xsaxpy();

/* xsnewplots.c */
extern LVAL iview_hist_adjust_to_data();
  xshistogram(),
  xsplot_points(),
  xsplot_lines(),
  xsspin_plot(),
  xsscatterplot_matrix(),
  xsnamelist();

#endif XLSEXT_H
